"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
const error_1 = require("../error");
function errorMiddleware(ctx, next) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            yield next();
        }
        catch (err) {
            const error = error_1.ResultError.isError(err) ? err : new error_1.ResultError('INTERNAL', 500, err);
            error.log();
            ctx.status = error.status;
            ctx.body = {
                error: error.code
            };
        }
    });
}
exports.errorMiddleware = errorMiddleware;
